<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Log user access if it logged in via .htpasswd
*    FileName $RCSfile: log_access.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3.4.1 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

// replace  with path to amember directory
include_once dirname(__FILE__) . '/config.inc.php';

//find out member_id
$login = $HTTP_SERVER_VARS['PHP_AUTH_USER'];
if (!strlen($login))
    $login = $HTTP_SERVER_VARS['REMOTE_USER'];
$ul = $db->users_find_by_string($login, 'login', 1);
if (!count($ul)) {
    $db->log_error("Unknown user was logged in: '$login'. Look like protection isn't setup correctly");
    exit();
}
$member_id = $ul[0]['member_id'];

// log access
$db->log_access($member_id);

session_start();
if (!$HTTP_SESSION_VARS['ip_checked']){ //skip if already checked
    if ($db->check_multiple_ip($member_id, $config['max_ip_count'], 
                    $config['max_ip_period'])){ //limit exceeded
        member_lock_by_ip($member_id);
    }                    
    $HTTP_SESSION_VARS['ip_checked'] = 1;
}
session_write_close();

?>
