<?php

add_paysystem_to_list(
array(
            'paysys_id' => 'beaverpay',
            'title'     => 'BeaverPay',
            'description' => 'See <a href="http://www.beaverpay.com" target=_blank>www.beaverpay.com</a> for description',
            'public'    => 1
        )
);

class payment_beaverpay extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config, $db;
        $products = $product_id;
        $orig_product_id = $product_id;
        if (is_array($product_id))
             $product_id = $product_id[0];

        $product = & get_product($product_id);
        if (count($orig_product_id)>1)
            $product->config['title'] = $config['multi_title'];

        $member = $db->get_user($member_id);

        $vars = array(
            'payee_email'    => $this->config['business'],
            'payer_email'  => $member['email'],
            'transaction_ref'  => $payment_id,
            'return_URL'      =>
               sprintf("%s/thanks.php?member_id=%d&product_id=%d",
                $config['root_url'],
                $member_id, $product_id),
            'cancel_URL' => $config['root_url']."/cancel.php",
            'notify_URL'  => $config['root_url'].
                             "/plugins/payment/beaverpay/ipn.php",
            'product_name' => $product->config['title'],
            'generic' => 1,
            'require_IPN' => 1,
            'amount'      => sprintf('%.2f', $price),
        );
 /*
        if ($product->config['is_recurring']){
            $vars += array(
                'amount'      => sprintf('%.2f', $price),
            );                        
        } else {
            $vars += array(
                'subscription' =>  'YES',
                'recurrent_charge' => sprintf('%.2f', $price),
                'duration' => beaverpay_period_to_days($product->config['expire_days']),
            );                        
            if ($product->config['trial1_days']){
                $vars += array(
                    'setup_fee' => sprintf('%.2f', $product->config['trial1_price']),
                    'trial_period' => beaverpay_period_to_days($product->config['trial1_days']),
                );                        
            }
        }
  */
        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://www.allresell.com/beaverpay/handle_gen.php?$vars");
        exit();
    }
}


?>