<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PayFlow Link Payment Plugin
*    FileName $RCSfile: echd.inc.php,v $
*    Release: 0.9 ($Revision: 1.1.2.1 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

add_paysystem_to_list(
array(
            'paysys_id' => 'echd',
            'title'     => 'ECommerceHelpdesk',
            'description' => 'secure credit card processing',
            'public'    => 1
        )
);

class payment_echd extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config, $db;
        $product = & get_product($product_id);
        $member = $db->get_user($member_id);

        $title = $product->config['title'];

        $vars = array(  
            'amount'        => sprintf('%.2f', $price),
            'f_ticket'        => $payment_id,
            'f_desc'          => $title,
            'route'           => $this->config['login'],
            'USERDEF5'        => $payment_id
        );

        global $t;
        $t->assign('vars', $vars);
        $t->assign('member', $member);
        $t->assign('this_config', $this->config);
        $t->display(preg_replace('/^c\:\\\\/', '/', dirname(__FILE__))."/pay.html");
        exit();
    }
}

?>
