<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: myvirtualcard.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

add_paysystem_to_list(
array(
            'paysys_id' => 'myvirtualcard',
            'title'     => 'myVirtualCard',
            'description' => 'See <a href="http://www.myvirtualcard.com" target="_blank">www.myvirtualcard.com</a> for description',
            'public'    => 1,
            'fixed_price' => 1
        )
);

// need to configure products in myvirtualcard and set thanks page to ./thanks.php
class payment_myvirtualcard extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config;
        $product = & get_product($product_id);

        $vars = array(
            'site_id' => $this->config['account'],
            'purchase' => sprintf('%.2f', $price),
            'MVC[payment_id]'    => $payment_id,
            'MVC[member_id]'    => $member_id,
            'MVC[product_id]'    => $product_id,
            'response_url'  => $config['root_url'].
                             "/plugins/payment/myvirtualcard/mpn.php"
        );
        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://www.myvirtualcard.com/transaction.php?$vars");
        exit();
    }
}

?>