<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PayFlow Link Payment Plugin
*    FileName $RCSfile: payflow_link.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.4.4.5 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

add_paysystem_to_list(
array(
            'paysys_id' => 'payflow_link',
            'title'     => 'PayFlow Link',
            'description' => 'See <a href="http://www.verisign.com/products/payflow/link/" target=_blank>www.verisign.com</a> for description',
            'public'    => 1
        )
);

class payment_payflow_link extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config;
        $product = & get_product($product_id);

        $vars = array(  
            'LOGIN'       => $this->config['login'],
            'PARTNER'     => $this->config['partner'],
            'AMOUNT'      => sprintf('%.2f', $price),
            'TYPE'        => 'S',
            'INVOICE'     => $payment_id,
            'DESCRIPTION' => $product->config['title']
        );

        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://payflowlink.verisign.com/payflowlink.cfm?$vars");
        exit();
    }
}

?>
