<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: check.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.9.2.4.4.22 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

////////////////// SAVE NAMESPACE BEFORE LITTER IT ///////////////////////////
$_list_vars = array_keys($GLOBALS);
//////////////////////////////////////////////////////////////////////////////
if (!is_array($_product_id)) die("Product ID is not defined in called script! Died.");

session_start();
if (@$HTTP_SESSION_VARS['_amember_login'] && 
    @$HTTP_SESSION_VARS['_amember_pass'] &&
    array_intersect((array)$HTTP_SESSION_VARS['_amember_product_ids'], 
            (array)$_product_id)){
    return;
}

$root = dirname(__FILE__) . '/../../..'; ## set it to root_dir if wrong
if (!defined('INCLUDED_AMEMBER_CONFIG'))
    include("$root/config.inc.php");

function _amember_check_access(){
    global $_product_id;
    global $db;
    global $HTTP_POST_VARS;
    global $HTTP_SESSION_VARS, $HTTP_COOKIE_VARS;
    global $config;

    $this_config = $config['plugins']['protect']['php_include'];

    global $_amember_login, $_amember_pass, $_amember_id;
    if (ini_get('register_globals')){
        session_register('_amember_login');
        session_register('_amember_pass');
        session_register('_amember_id');
        session_register('_amember_login_attempt_id');
    }
    $_amember_login = & $HTTP_SESSION_VARS['_amember_login'];
    $_amember_pass  = & $HTTP_SESSION_VARS['_amember_pass'];
    $_amember_id    = & $HTTP_SESSION_VARS['_amember_id'];

    //to track current user info
    global $_amember_user, $_amember_product_ids;
    global $_amember_products, $_amember_subscriptions;

    
    $HTTP_SESSION_VARS['_amember_user']          = array();
    $HTTP_SESSION_VARS['_amember_product_ids']   = array();
    $HTTP_SESSION_VARS['_amember_products']      = array();
    $HTTP_SESSION_VARS['_amember_subscriptions'] = array();
    $_amember_user          = array();
    $_amember_product_ids   = array();
    $_amember_products      = array();
    $_amember_subscriptions = array();

    $l = $HTTP_POST_VARS['amember_login'];
    $p = $HTTP_POST_VARS['amember_pass'];
    if (!strlen($l)) {
        $l = $_amember_login;
        $p = $_amember_pass;
    }
    if (!strlen($l)) {
        $l = $HTTP_COOKIE_VARS['_amember_ru'];
        $p = $HTTP_COOKIE_VARS['_amember_rp'];
    }
    if ($err = bruteforce_denied($l))
        return $err;

    // check for vBulletin login
    if (!strlen($l)){
        list($l, $p) = plugin_check_logged_in();
        $skip_bruteforce_check=1;
    } 
    ///
    if (in_array($HTTP_POST_VARS['login_attempt_id'], 
        (array)$HTTP_SESSION_VARS['_amember_login_attempt_id'])){
        return "Session expired, please enter username and password again";
    }


    if (strlen($l) && strlen($p)){
        ////
        if (!$db->check_login($l, $p, $_amember_id, $accept_md5=1)){
            if (!$skip_bruteforce_check) bruteforce_count($l);
            return "Incorrect login/password. Try again";
        }
        if (($_product_id[0] != 'ONLY_LOGIN')
            &&
            !$db->check_access($l, $_product_id)){
            $_SESSION['_amember_login'] = $l;
            $_SESSION['_amember_pass']  = $p;
            return "Access is not allowed. Please go to <a href=\"{$config['root_url']}/member.php\">\"Membership information page\"</a> to renew or add subscription";
        } else {
            $_amember_login = $l;
            $_amember_pass  = $p;

            /// check for ip violance
            /// lock user if it needed
            if (!$HTTP_SESSION_VARS['ip_checked']){ //skip if already checked
                if ($db->check_multiple_ip($_amember_id, $config['max_ip_count'], 
                                $config['max_ip_period'])){ //limit exceeded
                    member_lock_by_ip($_amember_id);
                }                    
                $HTTP_SESSION_VARS['ip_checked'] = 1;
            }

            // assign user info to session var '_amember_id 
            // and to same template var 
            $_amember_user  = $db->get_user($_amember_id);
            if ($_amember_user['data']['is_locked']>0)
                return 'Your account has been disabled. Contact site webmaster 
                for details.';

            if ($config['manually_approve'] && !$_amember_user['data']['is_approved']>0)
                return 'Your account is not yet enabled. You will receive an email when payment 
                processing will be completed.';

            if (!strcasecmp($l, $_amember_user['login']) && strcmp($l,  $_amember_user['login']))
                return "Enter username in correct case. You entered \"$l\", please enter \"$_amember_user[login]\" instead";

            // find out active subscriptions for this user
            $pl = (Array)$db->get_user_payments($_amember_id, 1);
            $today = date('Y-m-d');
            foreach ($pl as $pp){
                if (($pp['begin_date'] <= $today) && 
                    ($pp['expire_date'] >= $today)) {
                    $_amember_product_ids[]   = $pp['product_id'];
                    $_amember_subscriptions[] = $pp;
                }
            }
            $_amember_product_ids = array_unique($_amember_product_ids);
            foreach ($_amember_product_ids as $product_id){
                $pr = $db->get_product($product_id);;
                $urls = array();
                foreach ( preg_split('/[\r\n]+/', trim($pr['add_urls'])) as $u){
                    if (!strlen($u)) continue;
                    list($k, $v) = preg_split('/\|/', $u);
                    if (!$v) $v = $pr['title'];
                    $urls[$k] = $v;
                } 
                $pr['add_urls'] = $urls;
                $_amember_products[] = $pr;
            }

            if (ini_get('register_globals')){
                session_register('_amember_user');
                session_register('_amember_product_ids');
                session_register('_amember_products');
                session_register('_amember_subscriptions');
            }
            $HTTP_SESSION_VARS['_amember_user']          = $_amember_user         ;
            $HTTP_SESSION_VARS['_amember_product_ids']   = $_amember_product_ids  ;
            $HTTP_SESSION_VARS['_amember_products']      = $_amember_products     ;
            $HTTP_SESSION_VARS['_amember_subscriptions'] = $_amember_subscriptions;
            if ($HTTP_POST_VARS['login_attempt_id'])
                $HTTP_SESSION_VARS['_amember_login_attempt_id'][] = 
                    $HTTP_POST_VARS['login_attempt_id'];
            $db->log_access($_amember_id);
            php_include_remember_login($_amember_user);
            plugin_after_login($_amember_user);
            return '';
        }
    } 
    return 'Please Login';
}    

function php_include_remember_login($user){
    global $plugin_config;
    $this_config = $plugin_config['protect']['php_include'];
    if (!$this_config['remember_login']) return;
    $need = 0;
    if ($this_config['remember_auto']) 
        $need++;
    else {
        $vars = get_input_vars();
        if ($vars['remember_login']) $need++;
    }
    if (!$need) return;
    setcookie('_amember_ru', $user['login'], time() + $this_config['remember_period'] * 3600 * 24, '/');
    setcookie('_amember_rp', md5($user['pass']),  time() + $this_config['remember_period'] * 3600 * 24, '/');
}

function _amember_run(){
    if ($_amember_error = _amember_check_access()){
        /// serialize request variables
        global $_amember_prev_request, $HTTP_POST_VARS, $HTTP_GET_VARS, $HTTP_SERVER_VARS, $HTTP_SESSION_VARS;
//        if (!$HTTP_SESSION_VARS['_amember_prev_request']){
            $_SESSION['_amember_prev_request'] = $_amember_prev_request = array( 
                'GET'  => $HTTP_GET_VARS,
                'POST' => $HTTP_POST_VARS,
                'METHOD' => $HTTP_SERVER_VARS['REQUEST_METHOD']
            );
            if (ini_get('register_globals'))
                session_register('_amember_prev_request');
//        }
        /// display login form
        $t = & new_smarty();
        global $plugin_config;
        $t->assign('error', $_amember_error);
        $t->assign('this_config', $plugin_config['protect']['php_include']);
        $t->display('login.html');
        exit();
    } else { // auth successfull
        // extract serialized request vars
        global $HTTP_SESSION_VARS, $HTTP_GET_VARS, $HTTP_POST_VARS;
        global $_amember_prev_request;
        if ($o = $HTTP_SESSION_VARS['_amember_prev_request']){
//            $ord = ($o['METHOD'] == 'GET') ? array('POST', 'GET') : array('GET', 'POST');
            $HTTP_GET_VARS = $_GET = $o['GET'];
            $HTTP_POST_VARS = $_POST = $o['POST'];
            unset($_amember_prev_request);
            session_unregister('_amember_prev_request');
            unset($_SESSION['_amember_prev_request']);
            /// we don't set global variables here by security reasons
        }
    }
}

function bruteforce_count($login){
    global $db;
    $ul = $db->users_find_by_string($login, 'login', 1);
    if (!$ul) return;
    $u = $ul[0];
    $tm = time();
    $v  = $u['data']['bf_value'];
    $dt1 = $dt = $tm - $u['data']['bf_time'];
    if ($dt1 == 0) $dt1 = 0.5;
    $v -= $dt;
    if ($v < 0) $v = 0;
    $v += (($v + 2)/ $dt1);
    if ($v > 120) $v = 120;
    $u['data']['bf_time'] = $tm;
    $u['data']['bf_value'] = $v;
    $db->update_user($u['member_id'], $u);
}

function bruteforce_denied($login){
    global $db;
    $ul = $db->users_find_by_string($login, 'login', 1);
    if (!$ul) return;
    $u = $ul[0];
    $v  = $u['data']['bf_value'];
    $dt = time() - $u['data']['bf_time'];
    $v -= $dt;
    if ($v > 20)
        return "Please repeat login later (wait 2 minutes before next login attempt)";
}

function _amember_match_url(){
    global $config;
    global $HTTP_SERVER_VARS;
    foreach (array($config['root_url'], $config['root_surl']) as $url){
        $u = parse_url($url);
        $port = $HTTP_SERVER_VARS['SERVER_PORT'];
        $host = $HTTP_SERVER_VARS['HTTP_HOST'];
        $uri = $HTTP_SERVER_VARS['REQUEST_URI'];
        if (($u['scheme'] == 'http') && ($port == 443))
            continue;
        if (($u['scheme'] == 'https') && ($port == 80))
            continue;
        $s = preg_quote($u['path']);
        if (preg_match("|^$s|", $uri))
            return 1;
    }
}


_amember_run();

if (!_amember_match_url()){
    header("Location: $_SERVER[REQUEST_URI]");
    exit();
}

////////////////// CLEANUP NAMESPACE
foreach (array_keys($GLOBALS) as $k){
    if ($k == '_list_vars')             continue;
    if ($k == 'HTTP_SESSION_VARS')      continue;
    if ($k == 'HTTP_GET_VARS')          continue;
    if ($k == 'HTTP_POST_VARS')         continue;
    if ($k == 'HTTP_SERVER_VARS')       continue;
    if ($k == 'HTTP_REFERRER')          continue;
    if ($k == '_SESSION')               continue;
    if (session_is_registered($k))      continue;
    if (!in_array($k, $_list_vars)){
        unset($GLOBALS[$k]);
    }
}
unset($k);
unset($_list_vars);



?>
