<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Admin Login
*    FileName $RCSfile: login.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.10.2.4.4.6 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

global $HTTP_SESSION_VARS;

function _check_admin_password($l, $p){
    global $config;
    $cl = $config['admin_login'];
    $cp = $config['admin_pass'];
    if ($l != $cl) return 0;
        return crypt($p, $cp) == $cp;
}


function admin_auth(){
    global $config;
    global $HTTP_POST_VARS;
    global $HTTP_SESSION_VARS;
    global $vars;
    $do_login = $vars['do_login'];

    $l = $HTTP_SESSION_VARS['_admin_login'];
    $p = $HTTP_SESSION_VARS['_admin_pass'];

    if ($do_login) {
        $l = $HTTP_POST_VARS['login'];
        $p = $HTTP_POST_VARS['passwd'];
    }
    if (strlen($l) && strlen($p)){
        if ($err = admin_bruteforce_denied()) {
            return $err;
        }
        ////
        if (!_check_admin_password($l, $p)){
//            $HTTP_SESSION_VARS['_admin_login'] = '';
//            $HTTP_SESSION_VARS['_admin_pass']  = '';                    
            admin_bruteforce_count();
            return "Incorrect login/password. Try again";
        } else {
            global $_admin_login, $_admin_pass;
            $_admin_login = $HTTP_SESSION_VARS['_admin_login'] = $l;
            $_admin_pass  = $HTTP_SESSION_VARS['_admin_pass']  = $p;                    
            
            session_register('_admin_login');
            session_register('_admin_pass');
            return '';
        }
    } 
    return 'Please Login';
}    


function admin_login_form($err){
    global $t;
    global $do_login;
    if ($err)
        if ($err){
        $t->assign('error', $err);
        } else {
        $t->assign('error', 'Please login');
        }
    $t->display('admin/login.html');
    exit();
}

function admin_bruteforce_count(){
    global $db, $config;
    $bf_time = $config['_bf_time'];
    $bf_value = $config['_bf_value'];
    $tm = time();
    $v  = $bf_value;
    $dt1 = $dt = $tm - $bf_time;
    if ($dt1 == 0) $dt1 = 0.1;
    $v -= $dt;
    if ($v < 0) $v = 0;
    $v += (($v + 4)/ $dt1);
    if ($v > 480) $v = 480;
    $db->config_set('_bf_time', $tm, 0);
    $db->config_set('_bf_value', $v , 0);
}

function admin_bruteforce_denied(){
    global $config;
    $bf_time = $config['_bf_time'];
    $bf_value = $config['_bf_value'];
    $v  = $bf_value;
    $dt = time() - $bf_time;
    $v -= $dt;
    if ($v > 20)
        return "Please repeat login later (wait 5 minutes before next login attempt)";
}
///////////////////////////////////////////////////////////////////////////////

$vars = get_input_vars(); 
session_start();
if($err = admin_auth()) {                // authentication failed

  admin_login_form($err);               // display login form
  exit();
}
///// ****************************************************************
session_write_close();
session_start();
if ($config['_admin_last_session'] != session_id()){
    $_SESSION['_admin_last_login'] = $config['_admin_last_login'];
    $admin_last_login = $HTTP_SERVER_VARS['REMOTE_ADDR'];
    foreach (array('HTTP_X_FORWARDED_FOR', 'HTTP_PROXY_USER') as $k){
        if ($v=$HTTP_SERVER_VARS[$k]) {
            $admin_last_login .= " ($v)";
            break;
        }
    };
    $admin_last_login .= " at " . strftime($config['time_format'], time());
    $db->config_set('_admin_last_login', $admin_last_login,0);
    $db->config_set('_admin_last_session',session_id(),0);
} 
if ($t)
    $t->assign('SID', session_name().'='.session_id());
unset($vars);
?>
