<?php 
/*
*   Members page, used to login. If user have only 
*  one active subscription, redirect them to url
*  elsewhere, redirect to member.php page
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Member display page
*    FileName $RCSfile: login.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3.4.8 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

include('./config.inc.php');
$t = & new_smarty();
$_product_id = array('ONLY_LOGIN');

include($config['plugins_dir']['protect'] . '/php_include/check.inc.php');
$payments = & $db->get_user_payments(intval($HTTP_SESSION_VARS['_amember_id']), 1);
usort($payments, 'rcmp_begin_date');
$now = date('Y-m-d');
$urls = array();
foreach ($payments as $k=>$v){
    if (($v['expire_date'] >= $now) && ($v['begin_date'] <= $now)) {
        $p = get_product($v['product_id']);
        $url = $p->config['url'];
        if (strlen($url)){
            $urls[] = $url;
        }
    }
}

if ($_POST['amember_redirect_url']) {
        $redirect = $_POST['amember_redirect_url'];
} elseif (count(array_unique($urls)) == 1){
    if (in_array('htpasswd_secure', $plugins['protect'])){
        $member_login_pw = 
        htpasswd_secure_get_login($HTTP_SESSION_VARS['_amember_user']['login']).
        ':'.
        htpasswd_secure_get_passwd($HTTP_SESSION_VARS['_amember_user']['pass']);
        $redirect = add_password_to_url($urls[0], $member_login_pw);
    } else {
        if ($config['display_member_pw_urls']) {
             $member_login_pw = 
             $HTTP_SESSION_VARS['_amember_user']['login'].
             ':'.
             $HTTP_SESSION_VARS['_amember_user']['pass'];
             $redirect = add_password_to_url($urls[0], $member_login_pw);
        } else {
            $redirect = add_password_to_url($urls[0]);
        }
    }
} else {
    $redirect = $config['root_url'] . "/member.php";
}
#print_r($urls);
html_redirect("$redirect", 0, 'Redirect', "You will be redirected to protected area");
?>
