<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: payflow_pro payment plugin
*    FileName $RCSfile: anylink.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.2 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

global $config;
$_title = $config['payment']['anylink']['title'];
if ($_title == '') $_title = "Credit Card Payment";
$_desc = $config['payment']['anylink']['description'];
if ($_desc == '') $_desc = "all major credit cards accepted";

add_paysystem_to_list(
array(
            'paysys_id'   => 'anylink',
            'title'       => $_title,
            'description' => $_desc,
            'recurring'   => 0,
            'public'      => 1,
            'fixed_price' => 1
        )
);

add_product_field(
            'anylink_url', 'AnyLink URL',
            'text', 'URL where user will be redirected to make payment<br>
            if he chooses "anylink" payment option',
             'validate_anylink_url'
);

class payment_anylink extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        global $config, $db;
        $p = $db->get_payment($payment_id);
        $pr = $db->get_product($p['product_id']);
        $url = $pr['anylink_url'];
        if ($url == '') 
            fatal_error("Redirect URL is empty for product#$p[product_id]. Please contact site administrator");
        html_redirect("$url", 0, "Please wait...", "Redirecting you to secure payment page");
        exit();
    }
}

function validate_anylink_url(&$p, $field){  
    if ($p->config[$field] == '') 
        return "Please enter AnyLink URL for this product. If you don't like this requirement, disable AnyLink payment plugin";
    if (!preg_match('|http(s*)://.+/.+|', $p->config[$field])) 
        return "AnyLink URL must start from http:// or https:// and be valid absolute URL";
    return '';
}

?>