<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: authorize Link Single Payment Plugin
*    FileName $RCSfile: ipn.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.4.4.4 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

include "../../../config.inc.php";

$this_config = $plugin_config['payment']['authorize'];
$t = & new_smarty();
/////////////////////////////////////////////////////////////////////////////
$vars = get_input_vars();
$invoice    = intval($vars['x_invoice_num']);
$pnref      = $vars['x_trans_id'];
$amount     = doubleval($vars['x_amount']);
$result     = intval($vars['x_response_code']);
$respmsg    = $vars['x_response_reason_text'];

function get_dump($var){
//dump of array
    $s = "";
    foreach ($var as $k=>$v)
        $s .= "$k => $v<br>\n";
    return $s;
}


function authorize_error($msg){
    global $order_id, $invoice, $pnref;
    global $vars;
    fatal_error("authorize ERROR: $msg (Details: PNREF:'$pnref', invoice:'$invoice')<br>\n".get_dump($vars));
}

function authorize_user_error($msg){
    global $t;
    $t->assign(error, array("Error processing payment: <b>" 
        . $msg . "</b> Please return back and try again."));    
    $t->display('fatal_error.html');
    exit();
}

//////////////////////////////////////////////////////////////////////////////
//
//                           M   A   I   N
//
//////////////////////////////////////////////////////////////////////////////

if ($result != 1){
    authorize_user_error($respmsg);
}
if (!$amount){
    authorize_user_error("returned amount empty or = 0");
}

// get MD5
$md5source = $this_config['secret'] . $this_config['login'] . 
    $vars['x_trans_id'] . $vars['x_amount'];
$md5 = md5($md5source);
if (strtoupper($md5) != $vars['x_MD5_Hash']){
    authorize_error('MD5 hash incorrect');
}

// check test mode
if (!$vars['x_trans_id'] && !$this_config['testing']){
    authorize_error("Test transaction submitted, when aMember configured for live processing");
}

// process payment
$err = $db->finish_waiting_payment($invoice, 'authorize', 
        $pnref, $amount, $vars);
if ($err) 
    authorize_error("finish_waiting_payment error: $err");

// show thanks page
$t->display('thanks.html');
?>
