<?php
/*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: compuworld payment plugin config
*    FileName $RCSfile: config.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.1 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*/

global $config;
require_once(dirname(__FILE__)."/compuworld.inc.php");
require_once($config['root_dir']."/plugins/payment/cc_core/cc_core.inc.php");

$notebook_page = "CompuWorld";

config_set_notebook_comment($notebook_page, $notebook_page . ' configuration');
if (file_exists($rm = dirname(__FILE__) . "/readme.txt"))
    config_set_readme($notebook_page, $rm);

add_config_field('payment.compuworld.merchant_id', 'CompuWorld Merchant ID',
    'text', "your compuworld merchant id (Account Name)",
    $notebook_page, 
    '');
add_config_field('payment.compuworld.merchant_name', 'CompuWorld Merchant Name',
    'text', "your business name (for example \"CGI-Central\")",
    $notebook_page, 
    '');

cc_core_add_config_items('compuworld', $notebook_page);

?>