<?php
/*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: efsnet payment plugin config
*    FileName $RCSfile: config.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.2 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*/

global $config;
require_once(dirname(__FILE__)."/efsnet.inc.php");
require_once($config['root_dir']."/plugins/payment/cc_core/cc_core.inc.php");

$notebook_page = "EFSNet";

config_set_notebook_comment($notebook_page, $notebook_page . ' configuration');
if (file_exists($rm = dirname(__FILE__) . "/readme.txt"))
    config_set_readme($notebook_page, $rm);

add_config_field('payment.efsnet.store_id', 'EFSNet Store Id',
    'text', "your EFSNet id",
    $notebook_page, 
    '');
add_config_field('payment.efsnet.store_key', 'EFSNet Store Key',
    'text', "your EFSNet store <a href='https://testsecure.todaysebiz.com/ssl/services/welcome/ChangeStoreKey.asp' target=_blank>key</a>",
    $notebook_page, 
    '');
add_config_field('payment.efsnet.testing', 'Test Mode Enabled',
    'select', "set to No after you complete testing",
    $notebook_page, 
    '','','',
    array('options' => array(0 => 'No', 1 => 'Yes')));

cc_core_add_config_items('efsnet', $notebook_page);

?>