<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PayFlow Link Single Payment Plugin
*    FileName $RCSfile: ipn.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

include "../../../config.inc.php";

$this_config = $plugin_config['payment']['ematters'];
$t = & new_smarty();

/////////////////////////////////////////////////////////////////////////////
$vars = get_input_vars();
$result = $vars['rcode'];
$invoice = $vars['UID'];

function get_dump($var){
//dump of array
    $s = "";
    foreach ($var as $k=>$v)
        $s .= "$k => $v<br>\n";
    return $s;
}

function ematters_error($msg){
    global $order_id, $invoice, $pnref;
    global $vars;
    header("HTTP/1.1 404 Not found");
    header("Status: 404 Not Found");
    fatal_error("EMATTERS ERROR: $msg (Details: invoice:'$invoice')<br>\n".get_dump($vars));
}


//////////////////////////////////////////////////////////////////////////////
//
//                           M   A   I   N
//
//////////////////////////////////////////////////////////////////////////////

$p = $db->get_payment($invoice);
$rcode = $result - ($p['amount'] * 100) - ($this_config['merchant_id']*$vars['UID']);
$codes = array(
00 =>'Transaction approved.',
01 =>'Transaction declined. See card issuer.',
04 =>'Transaction declined. Call authorisation centre.',
08 =>'Transaction approved. Please sign receipt.',
12 =>'Transaction declined. Invalid transaction type.',
31 =>'Transaction declined. See card issuer.',
39 =>'Transaction declined. No CREDIT account.',
51 =>'Transaction declined. Insufficient funds.',
61 =>'Transaction declined. Over card limit.',
91 =>'Transaction declined. Issuer not available.',
708 =>'Non-Unique UID - Already accepted',
709 =>'Transaction Approved - Wrong Card Type',
810 =>'Invalid Purchase Amount',
812 =>'Unacceptable Card Number',
813 =>'Invalid Expiry Date Format',
816 =>'Card Expired',
980 =>'Host Not Found, Bank System out of action',
990 =>'Carrier Lost, Bank line down'
);
if (($rcode != 01) || ($rcode != 08)){
    $res = $codes[$rcode]; if ($res) $res = " $res";
    fatal_error("Transaction declined$res. Please try again");
}
// process payment
$err = $db->finish_waiting_payment($invoice, 'ematters', 
        '', '', $vars);

if ($err) 
    ematters_error("finish_waiting_payment error: $err");



?>
