<?
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: glo-bill payment plugin
*    FileName $RCSfile: globill.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.4.4 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

$plugins['payment'][] = 'globill_phone';
$plugins['payment'][] = 'globill_check';
add_paysystem_to_list(
array(
            'paysys_id' => 'globill',
            'title'     => 'Glo-Bill Credit Card',
            'description' => 'Pay with Visa, Mastercard, Checkcards, Discover, Eurocard, JCB, Diners cards, Electronic  via  <a href="http://www.globill.com" target=_blank>www.globill.com</a>',
            'public'    => 1,
            'recurring' => 1
        )
);

add_paysystem_to_list(
array(
            'paysys_id' => 'globill_phone',
            'title'     => 'Glo-Bill Phone',
            'description' => 'Pay easy over phone billing #900 via  <a href="http://www.globill.com" target=_blank>www.globill.com</a>',
            'public'    => 1,
            'recurring' => 1
        )
);

add_paysystem_to_list(
array(
            'paysys_id' => 'globill_check',
            'title'     => 'Glo-Bill Check',
            'description' => 'Pay with online check via <a href="http://www.globill.com" target=_blank>www.globill.com</a>',
            'public'    => 1,
            'recurring' => 1
        )
);

add_product_field(
            'globill_cc_id', 'GloBill CC ID',
            'text', 'you must create the same product<br>
             in GloBill for CC billing. Enter pricegroup here'
);

add_product_field(
            'globill_phone_id', 'GloBill Phone ID',
            'text', 'you must create the same product<br>
             in GloBill for Phone billing. Enter pricegroup here'
);

add_product_field(
            'globill_check_id', 'GloBill Check ID',
            'text', 'you must create the same product<br>
             in GloBill for Online Check payment. Enter pricegroup here'
);

// need to configure products in clickbank and set thanks page to ./thanks.php
class payment_globill extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config, $db, $plugin_config;
        $product = & get_product($product_id);
        $payment = $db->get_payment($payment_id);
        $member = $db->get_user($member_id);
        $this_config = $plugin_config['payment']['globill'];
        $vars = array(
            'id' => $this_config['site_id'],
            'username' => $member['login'],
            'password' => $member['pass'],
            'email' => $member['email'],
            'firstname' => $member['name_f'],
            'lastname' => $member['name_l'],
            'address' => $member['street'],
            'city' => $member['city'],
            'state' => $member['state'],
            'zip' => $member['zip'],
            'country' => $member['country'],
            'user1'  => $payment_id,
            'user2'  => $member_id,
            'user3'  => $product_id
        );

        if ($payment['paysys_id'] == 'globill'){
            $pg = $product->config['globill_cc_id'];
            if (!$pg) return "This product cannot be ordered with GloBill Credit Card";
        } elseif ($payment['paysys_id'] == 'globill_phone'){
            $vars['phonesign'] = 1;
            $pg = $product->config['globill_phone_id'];
            if (!$pg) return "This product cannot be ordered with GloBill Phone Billing";
        } elseif ($payment['paysys_id'] == 'globill_check'){
            $vars['check'] = 1;
            $pg = $product->config['globill_check_id'];
            if (!$pg) return "This product cannot be ordered with GloBill Online Check";
        } else {
            return "Internal Error: unknown paysys_id: '$payment[paysys_id]'";
        }

        $vars['pricegroup'] = $pg;
        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        if ($vars['phonesign'])
        header("Location: http://www.signup.globill-systems.com/cgi-bin/user/signup.cgi?$vars");
        else
        header("Location: https://www.globill-signup.com/cgi-bin/user/newsignup.cgi?$vars");
        $payment['paysys_id'] = 'globill';
        $db->update_payment($payment_id, $payment);
        exit();
    }
}

class payment_globill_phone extends payment_globill { 

}

class payment_globill_check extends payment_globill { 

}

?>
