<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PayFlow PRO payment plugin class
*    FileName $RCSfile: manual_cc.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.4 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/
    
add_member_field(
        'cc_street',
        'Billing Street Address',
        'text', 
        "",
        ''
);
add_member_field(
        'cc_city',
        'Billing City',
        'text', 
        "",
        ''
);
add_member_field(
        'cc_state',
        'Billing State',
        'select', 
        "",
        '', 
        array('options' => $config['state_options'])
);
add_member_field(
        'cc_zip',
        'Billing ZIP',
        'text', 
        "",
        ''
);
add_member_field(
        'cc_country',
        'Billing Country',
        'select', 
        "",
        '', 
        array('options' => $config['country_options'])
);

add_member_field(
        'cc',
        'Credit Card # (visible)',
        'readonly', 
        "credit card number (read-only)",
        ''
);

if ($config['payment']['manual_cc']['ask_cvv2']) {
    add_member_field(
            'cc-code',
            'Credit Card Code',
            'readonly', 
            "credit card code (read-only)",
            ''
    );
    $config['cc_code'] = 1;
}
add_member_field(
        'cc-hidden',
        'Credit Card # (crypted)',
        'hidden', 
        '',
        ''
);

add_member_field(
        'cc-expire',
        'Credit Card Expire',
        'readonly', 
        'Expiration date (mmyy)',
        ''
);

add_paysystem_to_list(
array(
            'paysys_id' => 'manual_cc',
            'title'     => 'Credit Card',
            'description' => 'Credit Card payment',
            'public'    => 1,
            'recurring' => 1
        )
);

class payment_manual_cc extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        global $config;
        header("Location: $config[root_surl]/plugins/payment/manual_cc/cc.php?payment_id=$payment_id&member_id=$member_id");
        return '';
    }
}

function manual_cc_get_member_links($user){
    global $config;
    if ($user['data']['cc'])
        return array("$config[root_surl]/plugins/payment/manual_cc/cc.php?renew_cc=1&member_id=$user[member_id]" => 'Update CC info');
}


?>
