<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: mpn.php,v $
*    Release: 1.9.3RC22PRO ($Revision: 1.1.2.2 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/

include "../../../config.inc.php";

//$myvirtualcard_debug = false; // must be defined here! (false or true)
$this_config = $plugin_config['payment']['myvirtualcard'];

function get_dump($var){
	//dump of array
	$s = "";
	foreach ($var as $k=>$v)
	$s .= "$k => $v<br>\n";
	return $s;
}

function myvirtualcard_error($msg){
	global $payment_id, $invoice;
	global $vars;
	header("HTTP/1.1 404 Not found");
	header("Status: 404 Not Found");
	fatal_error("MYVIRTUALCARD ERROR: $msg (Details: payment_id:'$payment_id', invoice:'$invoice')<br>\n".get_dump($vars));
}

// read post from myVirtualCard system and add 'cmd'
$myvirtualcard_debug = false;
$vars = $myvirtualcard_debug ? $HTTP_GET_VARS : $HTTP_POST_VARS;

$req = "trans_id={$vars['transaction_id']}";

$payment_id   = intval($vars['mvc_payment_id']);
$member_id    = intval($vars['mvc_member_id']);
$product_id   = intval($vars['mvc_product_id']);

$invoice      = $vars['transaction_id'];
$amount       = $vars['purchase'];
$status       = $vars['status'];

$db->log_error("MYVIRTUALCARD DEBUG<br>\n".get_dump($vars));

// post back to myVirtualCard system to validate
$header .= "POST /Services/TransactionVerification.php HTTP/1.0\r\n";
$header .= "HOST: www.myvirtualcard.com\r\n";
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen ($req) . "\r\n\r\n";

if (!$myvirtualcard_debug) {
	$fp = fsockopen ("www.myvirtualcard.com", 80, $errno, $errstr, 30);
} else {
	$fp = fopen('test.txt', 'r');
}

if (!$fp) {
	// HTTP ERROR
	myvirtualcard_error("FOPEN www.myvirtualcard.com $errstr ($errno)");
} else {
	
	fputs ($fp, $header . $req);
	$res = '';
	while (!feof($fp)) {
		$res .= fgets ($fp, 1024);
	}
	fclose ($fp);
	
	
	list(, $res) = explode("\r\n\r\n", $res);
	
	parse_str($res, $res_vars);
	
	
	if ( $res_vars['status'] == 'success' && $res_vars['site_id'] == $this_config['account'] ) {
		$err = $db->finish_waiting_payment($payment_id, 'myvirtualcard',
		$invoice, $amount, $vars);
	} else {
		myvirtualcard_error('INVALID answer from myVirtualCard server.  Possible hack attempt.');
	}
}

?>