<?php

include "../../../config.inc.php";

$this_config = $plugin_config['payment']['passwordcall'];

function get_dump($var){
//dump of array
    $s = "";
    foreach ((array)$var as $k=>$v)
        $s .= "$k => $v<br>\n";
    return $s;
}

function passwordcall_error($msg){
    global $txn_id, $invoice;
    global $vars;
    fatal_error("passwordcall ERROR: $msg (Details: txn_id:'$txn_id', invoice:'$invoice')<br>\n".get_dump($vars));
}

// read post from passwordcall system and add 'cmd'
$vars = get_input_vars();

$req = 'cmd=_notify-validate';
foreach ($vars as $k => $v) {
    if (get_magic_quotes_gpc())
        $vars[$k] = $v = stripslashes($v);
    $req .= "&" . urlencode($k) . "=" . urlencode ($v);
}

// assign posted variables to local variables
$invoice        = $vars['transaction_ref'];
$webmaster_id    = $vars['wmid'];

$db->log_error("passwordcall DEBUG<br>\n".get_dump($vars));

if ($webmaster_id != $this_config['webmaster_id'])
    passwordcall_error("False webmaster id: '$webmaster_id'");

// process payment
$err = $db->finish_waiting_payment($invoice, 'passwordcall',
        $vars);
if ($err)
    passwordcall_error("finish_waiting_payment error: $err");

?>