<?php

add_paysystem_to_list(
array(
            'paysys_id' => 'passwordcall',
            'title'     => 'PasswordCall',
            'description' => 'See <a href="http://www.passwordcall.de" target=_blank>www.passwordcall.de</a> for description',
            'public'    => 1
        )
);

class payment_passwordcall extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config, $db;
        $products = $product_id;
        $orig_product_id = $product_id;
        if (is_array($product_id))
             $product_id = $product_id[0];

        $product = & get_product($product_id);
        if (count($orig_product_id)>1)
            $product->config['title'] = $config['multi_title'];

        $member = $db->get_user($member_id);

        $vars = array(
            'transaction_ref'  => $payment_id,
            'wmid'    => $this->config['webmaster_id'],
            'agbid1'    => $this->config['angebots_id1'],
            'agbid2'    => $this->config['angebots_id2'],
            'product_id' => $product_id,
            'member_id' => $member_id,
        );

        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: ".$config['root_url']."/plugins/payment/passwordcall/passwordcall.php?".$vars);
        exit();
    }
}

?>