<?php 

$notebook_page = 'PaySystems.Com';
config_set_notebook_comment($notebook_page, 'PaySystems.Com plugin configuration');
if (file_exists($rm = dirname(__FILE__)."/readme.txt"))
    config_set_readme($notebook_page, $rm);

add_config_field('payment.paysystems.company_id', 'Merchant ID',
    'integer', "",
    $notebook_page, 
    'validate_integer');
add_config_field('payment.paysystems.ip', 'PostBack IP',
    'textarea', "IP of PaySystems server which send PostBack<br>
    don't change it if you are not sure what it means<br>
    You can use * as wildcard symbol",
    $notebook_page, 
    '','','',
    array('default'=>"66.201.123.*\n207.107.231.*", 'cols' => 13)
    );

if (class_exists('payment_paysystems')) {
    $pl = & instantiate_plugin('payment', 'paysystems');
    $pl->add_config_items($notebook_page);
}

add_config_field('payment.paysystems.resend_postback', 'Resend Postback',
    'textarea', "URL List to resend PostBack<br>
    please discuss your situation with CGI-Central support<br>
    before use this feature. It is better to keep this field blank",
    $notebook_page, 
    '','','',
    array('default'=>"", 'cols' => 40)
    );

?>
