<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: privatepay.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.2 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

add_paysystem_to_list(
array(
            'paysys_id' => 'privatepay',
            'title'     => 'PrivatePay',
            'description' => 'See <a href="http://www.privatepay.com" target=_blank>www.privatepay.com</a> for description',
            'public'    => 1,
            'fixed_price' => 1
        )
);

add_product_field(
            'privatepay_id', 'PrivatePay ID',
            'text', 'you must create the same product<br>
             in PrivatePay and enter its number here',
             'validate_privatepay_id'
);


// need to configure products in privatepay and set thanks page to ./thanks.php
class payment_privatepay extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config;
        $product = & get_product($product_id);

        $c_product_id = $product->config['privatepay_id'];

        if (!$c_product_id)
            fatal_error("PrivatePay Product ID empty for Product# $product_id");

        $vars = array(
            'vendor' => $this->config['account'],
            'action' => 'add',
            'quantity' => 1,
            'name' => $c_product_id,
        );
        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://www.private-pay.com/secure/vendor/vendorcart?$vars");
        exit();
    }
}

function validate_privatepay_id(&$p, $field){  
    if (!$p->config[$field]) {
        return "You MUST enter PrivatePay Product ID while you're using PrivatePay Plugin";
    }
    return '';
}
?>
