<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: psigate.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.2 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

add_paysystem_to_list(
array(
            'paysys_id' => 'psigate',
            'title'     => 'PsiGate',
            'description' => 'Credit Card Payment',
            'public'    => 1,
            'fixed_price' => 1
        )
);

// need to configure products in clickbank and set thanks page to ./thanks.php
class payment_psigate extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $db, $config, $plugin_config;
        $member = $db->get_user($member_id); 
        $vars = array(  
            'MerchantId'    => $this->config['merchant_id'],
            'FullTotal'     => sprintf('%.2f', $price),
            'Oid'    =>  $payment_id,
            'Phone'  =>  $member['data']['phone'],
            'Email' =>   $member['email'],
            'ChargeType' => '0',
            'Result' => intval($this->config['testing']),
            'ThanksURL' => $config['root_url'].'/plugins/payment/psigate/thanks.php',
            'NoThanksURL' => $config['root_url'].'/plugins/payment/psigate/no_thanks.php'
        );
/*
            'CardNumber' => $cc_number,
            'ExpMonth' => substr($cc_expire, 0, 2),
            'ExpYear'  => substr($cc_expire, 2, 2),
            'Bname'  =>  $member['name_f']  . ' ' . $member['name_l'],
            'Baddr1'  => $member['cc_street'],
            'Bcity'  =>  $member['cc_city'],
            'Bstate'  => $member['cc_state'],
            'Bzip'  =>   $member['cc_zip'],
            'Bcountry' => $member['cc_country'],
*/
        $t = & new_smarty();
        $t->template_dir = dirname(__FILE__);
        $t->assign(array(
            'header' => $config['root_dir'] . '/templates/header.html',
            'footer' => $config['root_dir'] . '/templates/footer.html',
            'this_config' => $this->config,
            'member'  => $db->get_user($member_id),
            'payment' => $pm = $db->get_payment($payment_id),
            'product' => $db->get_product($pm['product_id']),
            'vars' => $vars,
            'customer_name' => $member['name_f'] . ' ' . $member['name_l']
        ));
        $t->display('psigate.html');
        exit();
    }
    function validate_thanks(&$vars){
        return ($vars['OrdNo']>0) ? "" : "Internal Error";
    }
    function process_thanks(&$vars){
            global $db;
            $err = $db->finish_waiting_payment(intval($vars['OrdNo']), 
                    'psigate', $vars['RefNo'], $vars['Total'],
                     $vars);
            if ($err) 
                return "finish_waiting_payment error: $err";
    }
}

?>
